#
# 68EC030-Cisco/Makefile
#
# This file is included by the global makefile so that you can add your own
# platform-specific flags and dependencies.
#
# This file is subject to the terms and conditions of the GNU General Public
# License.  See the file "COPYING" in the main directory of this archive
# for more details.
#
# Copyright (C) 1999 by Greg Ungerer (gerg@moreton.com.au)
# Copyright (C) 1998,1999  D. Jeff Dionne <jeff@rt-control.com>
# Copyright (C) 1998       Kenneth Albanowski <kjahds@kjahds.com>
# Copyright (C) 1994 by Hamish Macdonald
#

CROSS_COMPILE = m68k-aout-


CFLAGS := $(CFLAGS) -I$(INCGCC) -pipe -DNO_MM -DNO_FPU -DBIGALLOCS -m68030 -msoft-float -Wa,-m68030 -D__AOUT__ -DMAGIC_ROM_PTR -DUTS_SYSNAME='"uClinux"'
#CFLAGS := $(CFLAGS) -I$(INCGCC) -pipe -DNO_MM -DNO_FPU -DBIGALLOCS -m68030 -Wa,-S -Wa,-m68030 -D__AOUT__ -DMAGIC_ROM_PTR -DUTS_SYSNAME='"uClinux"'
AFLAGS := $(CFLAGS)

LINKFLAGS = -T arch/$(ARCH)/platform/$(PLATFORM)/$(BOARD)/$(MODEL).ld -omagic

HEAD := arch/$(ARCH)/platform/$(PLATFORM)/$(BOARD)/crt0_$(MODEL).o

SUBDIRS := arch/$(ARCH)/kernel arch/$(ARCH)/mm arch/$(ARCH)/lib \
           arch/$(ARCH)/platform/$(PLATFORM) $(SUBDIRS)
ARCHIVES := arch/$(ARCH)/kernel/kernel.o arch/$(ARCH)/mm/mm.o \
            arch/$(ARCH)/platform/$(PLATFORM)/platform.o $(ARCHIVES)
LIBS += arch/$(ARCH)/lib/lib.a 

MAKEBOOT = $(MAKE) -C arch/$(ARCH)/boot

linux.bin: linux
	cp linux linux.bin
	m68k-aout-strip linux.bin

archclean:
	@$(MAKEBOOT) clean
	rm -f linux.bin
