#
#	build.mk -- common definitions for building user apps.
#

.EXPORT_ALL_VARIABLES:

CC      = $(TOOLS)/m68k-linux-gnu-gcc
CPP     = $(TOOLS)/m68k-linux-gnu-g++
AR      = $(TOOLS)/m68k-linux-gnu-ar
LD      = $(TOOLS)/m68k-linux-gnu-ld -r
OBJCOPY = $(TOOLS)/m68k-linux-gnu-objcopy
RANLIB  = $(TOOLS)/m68k-linux-gnu-ranlib
ELF2FLT = $(TOOLS)/elf2flt

GCC_EXEC_PREFIX = $(TOOLS)/m68k-linux-gnu-

LIBC    = $(ROOTDIR)/lib/libc/libc.a
LIBM    = $(ROOTDIR)/lib/libm/libmf.a
LIBNET  = $(ROOTDIR)/lib/libnet/libnet.a
LIBDES  = $(ROOTDIR)/lib/libdes/libdes.a
LIBGCC  = $(TOOLS)/../lib/libgcc.a

INCLIBC = -I$(ROOTDIR)/lib/libc/include
INCLIBM = -I$(ROOTDIR)/lib/libm
INCNET  = -I$(ROOTDIR)/lib/libnet
INCDES  = -I$(ROOTDIR)/lib/libdes
INCGCC  = -I$(TOOLS)/gcc-include

ARCH    = -m68030 -Wa,-m68030
DEFS    = -Dlinux -D__linux__ -Dunix -DEMBED
INCS    = $(INCGCC) $(INCLIBC) $(INCLIBM)
CCFLAGS =  -O2 -msoft-float -fno-builtin
CFLAGS  = $(ARCH) $(DEFS) $(CCFLAGS) $(INCS)

LDSCRIPT = $(ROOTDIR)/user/arch/coldfire/user.ld
STARTUP  = $(ROOTDIR)/lib/libc/crt0.o
LDFLAGS  = -T $(LDSCRIPT) $(STARTUP)
LDLIBS   = $(LIBC) $(LIBGCC)
CONVERT  = $(ELF2FLT) $$(FLTFLAGS) -o $$@ $$@.elf

