/*****************************************************************************/

/*
 *	login.c -- simple login program.
 *
 *	(C) Copyright 1999, Greg Ungerer (gerg@moreton.com.au).
 *	made some changes and additions Nick Brok (nick@nbrok.iaehv.nl).
 */

/*****************************************************************************/

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <getopt.h>
#include <errno.h>
#include <string.h>
#include <sys/utsname.h>

/* Delay bad password exit.
 * 
 * This doesn't really accomplish anything I guess..
 * as other connections can be made in the meantime.. and
 * someone attempting a brute force attack could kill their
 * connection if a delay is detected etc.
 *
 * -m2 (20000201)
 */
#define DELAY_EXIT	1


/*****************************************************************************/

char *version = "v1.0.1";

/*****************************************************************************/

char *getrealpass(char *pfile)
{
	static char	tmpline[128];
	FILE		*fp;
	char		*spass;
	int		len;

	if ((fp = fopen(pfile, "r")) < 0) {
		fprintf(stderr, "ERROR: failed to open(%s), errno=errno \n",
			errno);
		return((char *) NULL);
	}

	while (fgets(tmpline, sizeof(tmpline), fp)) {
		spass = strchr(tmpline, ' ');
		if (spass) {
			*spass++ = 0;
			if (strcmp(tmpline, "passwd") == 0) {
				len = strlen(spass);
				if (spass[len-1] == '\n')
					spass[len-1] = 0;
				return(spass);
			}
		}
	}

	fclose(fp);
	return((char *) NULL);
}

/*****************************************************************************/

int main(int argc, char *argv[])
{
	char	*realpwd, *gotpwd;

#ifdef CONFIG_NETtel
	gotpwd = getpass("NETtel Login: root\nPassword: ");
	realpwd = getrealpass("/etc/config/config");
#else
	struct	utsname	name;
	if (uname(&name)==-1) { perror("Error: "); exit(0); }
	printf("Welcome! root password is cisco\n");
	gotpwd = getpass("Enter root password: ");
	realpwd = "cisco";
#endif
	if (gotpwd && realpwd) {
		if (strcmp(gotpwd, realpwd) == 0)
			execlp("sh", "sh", "-t", NULL);
#if DELAY_EXIT
#define DELAY	1
		else
			sleep(DELAY);
#endif
	}
	exit(0);
}

/*****************************************************************************/
