/*****************************************************************************/

/*
 *	passwd.c -- simple change password program.
 *
 *	(C) Copyright 1999, Nick Brok (nick@nbrok.iaehv.nl).
 */

/*****************************************************************************/

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <getopt.h>
#include <errno.h>
#include <string.h>

/*****************************************************************************/

char *version = "v1.0.1";

#ifdef CONFIG_NETtel
#define	PASSWDFILE	"/etc/config/config"
#else
#define	PASSWDFILE	"/var/passwd"
#endif

/*****************************************************************************/

int putpassword (char *pfile, char *password)
{
        static char     tmpline[128];
        FILE            *fp;
        int             len;

        if ((fp = fopen(pfile, "w")) == NULL) 
	{
                fprintf(stderr, "ERROR: failed to create or open ( %s ).\n",pfile);
		fflush(stderr);
                return(1);
        }
	tmpline[0]=0;
	strcat(tmpline,"passwd ");
	strcat(tmpline,password);
	strcat(tmpline,"\n");
        len=fputs(tmpline,fp);
        fclose(fp);
        return(len);
}

int main(int argc, char *argv[])
{
	char	*cryptmode, password2[128], password1[128];
	int	n=1;


	while (n==1)
	{
		strcpy(password1, getpass("Enter new Unix password: "));
		cryptmode = "ab";
		strcpy(password2, getpass("Re-enter new Unix password: "));
		if (strcmp(password1,password2) == 0)
		{
			if ( putpassword(PASSWDFILE,crypt(password1,cryptmode)))
			{
				printf("Root password changed successfully\n");
				n=0;
			}
			else
			{
			fprintf(stderr,"passwd file error, password not changed!\n");
			fflush(stderr);
			n=0;
			}
		}
		else
		{
			printf("Password not matched, try again.\n");
			n=1;
		}
	}
}

/*****************************************************************************/
